import { browser, ExpectedConditions as ec /* , promise */ } from 'protractor';
import { NavBarPage, SignInPage } from '../../page-objects/jhi-page-objects';

import {
  SavedSearchesComponentsPage,
  /* SavedSearchesDeleteDialog, */
  SavedSearchesUpdatePage,
} from './saved-searches.page-object';

const expect = chai.expect;

describe('SavedSearches e2e test', () => {
  let navBarPage: NavBarPage;
  let signInPage: SignInPage;
  let savedSearchesComponentsPage: SavedSearchesComponentsPage;
  let savedSearchesUpdatePage: SavedSearchesUpdatePage;
  /* let savedSearchesDeleteDialog: SavedSearchesDeleteDialog; */
  const username = process.env.E2E_USERNAME ?? 'admin';
  const password = process.env.E2E_PASSWORD ?? 'search@admin';

  before(async () => {
    await browser.get('/');
    navBarPage = new NavBarPage();
    signInPage = await navBarPage.getSignInPage();
    signInPage.autoSignInUsing('admin', 'search@admin');
    await browser.wait(ec.visibilityOf(navBarPage.entityMenu), 5000);
    // await navBarPage.clickOnEntityMenu();
  });

  it('should load SavedSearches', async () => {
    await navBarPage.goToEntity('saved-searches');
    savedSearchesComponentsPage = new SavedSearchesComponentsPage();
    await browser.wait(ec.visibilityOf(savedSearchesComponentsPage.title), 5000);
    expect(await savedSearchesComponentsPage.getTitle()).to.eq('gitsearchApp.savedSearches.home.title');
    await browser.wait(
      ec.or(ec.visibilityOf(savedSearchesComponentsPage.entities), ec.visibilityOf(savedSearchesComponentsPage.noResult)),
      1000
    );
  });

  it('should load create SavedSearches page', async () => {
    await savedSearchesComponentsPage.clickOnCreateButton();
    savedSearchesUpdatePage = new SavedSearchesUpdatePage();
    expect(await savedSearchesUpdatePage.getPageTitle()).to.eq('gitsearchApp.savedSearches.home.createOrEditLabel');
    await savedSearchesUpdatePage.cancel();
  });

  /* it('should create and save SavedSearches', async () => {
        const nbButtonsBeforeCreate = await savedSearchesComponentsPage.countDeleteButtons();

        await savedSearchesComponentsPage.clickOnCreateButton();

        await promise.all([
            savedSearchesUpdatePage.setNameInput('name'),
            savedSearchesUpdatePage.setJsonQueryInput('jsonQuery'),
            savedSearchesUpdatePage.userSelectLastOption(),
        ]);

        await savedSearchesUpdatePage.save();
        expect(await savedSearchesUpdatePage.getSaveButton().isPresent(), 'Expected save button disappear').to.be.false;

        expect(await savedSearchesComponentsPage.countDeleteButtons()).to.eq(nbButtonsBeforeCreate + 1, 'Expected one more entry in the table');
    }); */

  /* it('should delete last SavedSearches', async () => {
        const nbButtonsBeforeDelete = await savedSearchesComponentsPage.countDeleteButtons();
        await savedSearchesComponentsPage.clickOnLastDeleteButton();

        savedSearchesDeleteDialog = new SavedSearchesDeleteDialog();
        expect(await savedSearchesDeleteDialog.getDialogTitle())
            .to.eq('gitsearchApp.savedSearches.delete.question');
        await savedSearchesDeleteDialog.clickOnConfirmButton();
        await browser.wait(ec.visibilityOf(savedSearchesComponentsPage.title), 5000);

        expect(await savedSearchesComponentsPage.countDeleteButtons()).to.eq(nbButtonsBeforeDelete - 1);
    }); */

  after(async () => {
    await navBarPage.autoSignOut();
  });
});
